 /**
 * @author: Mari Carmen Otero
 */

package febrero;

import javabook.*;

class PermutacionCol2
{
    //atributos
    private MainWindow ventanaPrincipal;
    private InputBox cuadroEntrada;
    private OutputBox cuadroSalida;
    private MessageBox cuadroMensaje;
    private ResponseBox cuadroRespuesta;
    private String mensajeEntrada;
    private String claveCifrado;
    private String mensajeSalida;

    //constructor
    public PermutacionCol2()
    {
        ventanaPrincipal = new MainWindow();
      	cuadroEntrada = new InputBox (ventanaPrincipal);
      	cuadroSalida = new OutputBox (ventanaPrincipal);
      	cuadroMensaje = new MessageBox (ventanaPrincipal);
      	cuadroRespuesta = new ResponseBox (ventanaPrincipal);

      	ventanaPrincipal.setVisible(true);
      	cuadroSalida.show();
    }

    //metodo empezar
    public void empezar()
    {
        String mensajeSalida = null;
      	int respuesta;
      	respuesta = cuadroRespuesta.prompt("Quieres encriptar mensajes segn el mtodo de permutacin columnar?");
      	while (respuesta == cuadroRespuesta.YES)
      	{

          	leerMensaje();
          	leerClave();

          	mensajeSalida = encriptarMensaje();

          	mostrarMensajes(mensajeSalida);

          	respuesta = cuadroRespuesta.prompt("Quieres encriptar mensajes segn el mtodo de permutacin columnar?");
      	}
    }

    //mtodo leerMensaje
    private void leerMensaje()
    {
        do
      	{
            mensajeEntrada = cuadroEntrada.getString("Introduce el mensaje:");
            if (validarMensaje() == false)
              cuadroMensaje.show("El mensaje debe ser de longitud mltiplo de 8.");
  	   	} while (validarMensaje() == false);
  	}

  	//mtodo validarMensaje
  	private boolean validarMensaje()
  	{
		boolean esCorrecto = true;
		if (mensajeEntrada.length() % 8 != 0)
        esCorrecto = false;
    return esCorrecto;
    }

    //mtodo leerClave
    private void leerClave()
    {
        boolean esNumerica = true;
        boolean esNoRepetida = true;

        do
        {
            claveCifrado = cuadroEntrada.getString ("Introduce la clave: ");

            esNumerica = validarDigitosNumericos();
            esNoRepetida = validarDigitosNoRepetidos();

            if (esNumerica == false)
                cuadroMensaje.show("Los dgitos de la clave deben pertenecer a [0,7]. Repetir");

            if (esNoRepetida == false)
                cuadroMensaje.show("Los dgitos de la clave estn repetidos. Repetir");

        } while (!esNumerica || !esNoRepetida);
    }

    //mtodo validarDigitosNumericos
    private boolean validarDigitosNumericos()
    {
        int i = 0;
        boolean claveNumerica = true;
  
        while (i < 8 && claveNumerica)
        {
            if (claveCifrado.charAt(i) < '0' || claveCifrado.charAt(i) > '7')
                claveNumerica = false;
            else
                i++;
        }
        return claveNumerica;
    }

    //mtodo validarDigitosNoRepetidos
    private boolean validarDigitosNoRepetidos()
    {
        char carActual;
        int i = 0, j = 0;
        boolean claveNoRepetida = true;
        do
        {
            i++;
            carActual = claveCifrado.charAt(i);
            j = 0;

            while (j < i && claveNoRepetida)
            {
                if (carActual == claveCifrado.charAt(j))
                    claveNoRepetida = false;
                else
                    j++;
            }

        } while (i < 7 && claveNoRepetida);
  
      	return claveNoRepetida;
    }

    //mtodo encriptarMensaje
    private String encriptarMensaje()
    {
        StringBuffer objetoTemp = new StringBuffer();
        int longitud = mensajeEntrada.length();
        String letraClave = null;
        int indice;
        char caracterEncriptado;

        for (int i = 0; i < longitud; i = i + 8)
        {
            for (int j = 0; j < 8; j++)
            {
                letraClave = claveCifrado.substring(j,j+1);
          			indice = Integer.parseInt(letraClave);
                indice = indice + i;
                caracterEncriptado = mensajeEntrada.charAt(indice);
                objetoTemp.append(caracterEncriptado);
            }
        }
        return objetoTemp.toString();
    }

    //mtodo mostrarMensajes
    private void mostrarMensajes(String mensajeSalida)
    {
      cuadroSalida.printLine ("Mensaje de entrada: " + mensajeEntrada);
      cuadroSalida.printLine ("CLAVE: " + claveCifrado);
      cuadroSalida.printLine ("Mensaje de salida:  " + mensajeSalida);
    }
}
